/*
 * C
 *
 * Copyright 2013 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

#include "sni.h"

#include <stdio.h>

#define ERROR_OUT_OF_RESOURCES -1

#define RESOURCE_LIMIT 2
static uint8_t resource_in_use[RESOURCE_LIMIT];

jint Java_com_is2t_example_ResourceUser_allocateResource() {
	jint id;
    jint result = ERROR_OUT_OF_RESOURCES;
    for (id = 0; id < RESOURCE_LIMIT; ++id) {
        if (!resource_in_use[id]) {
            result = id;
            resource_in_use[id] = 1;
            break;
        }
    }
    printf("Allocating resource %i\n", result);
    return result;;
}

void Java_com_is2t_example_ResourceUser_useResource__I(jint id) {
    printf("Using resource %i\n", id);
}

void Java_com_is2t_example_ResourceUser_releaseResource(jint id) {
    printf("Releasing resource %i\n", id);
    resource_in_use[id] = 0;
}
