/**
 * Java
 * 
 * Copyright 2013 IS2T. All rights reserved
 * For demonstration purpose only
 * IS2T PROPRIETARY. Use is subject to license terms.
 */
package com.is2t.example;

import com.is2t.example.ResourceManager.OutOfResourcesException;

class ResourceUser {
    public static final int ERROR_OUT_OF_RESOURCES = -1;

    private static final ResourceManager resourceManager = new ResourceManager();

    private final int cResourceId;
    
    public ResourceUser() throws OutOfResourcesException {
        ResourceUserHelper helper = new ResourceUserHelper();
        resourceManager.allocateResource(this, helper);
        cResourceId = helper.getResourceId();
    }

    public int getCResourceId() {
        return cResourceId;
    }

    public void useResource() {
        useResource(cResourceId);
    }

    native static int allocateResource();
    private native static void useResource(int cResourceId);
    native static void releaseResource(int cResourceId);
}